//I know this code is kinda ugly...
//Made for a Teensy++ 2.0 and some improvised perfboard.

#include <FastLED.h>
#include <fix_fft.h>

//SAMPLING
#define CHANNEL 39
#define samples 64 //This value MUST ALWAYS be a power of 2
const double samplingFrequency = 3500; //Hz, must be less than 10000 due to ADC limitations.
int i;
unsigned int sampling_period_us;
unsigned long microseconds;

//FFT
char im[samples];
char data[samples]; 

//FastLED setup
#define LED_Count 6
#define LED_Output  24
#define HUE_Min 160
#define HUE_Max 225
#define BrightMax 130
CRGB leds[LED_Count];
int hue_div = (HUE_Max - HUE_Min) / LED_Count;
int sample_sum_step = ((samples/2 - 1)/LED_Count)-1;
int fft_sum = 0;
bool audio;

//VARIOUS INPUTS
#define SwitchPin1 3
#define SwitchPin2 1

#define RPot 41
#define GPot 42
#define BPot 43
int red = 0;
int green = 0;
int blue = 0;

void setup()
{

  delay(50);
  digitalWrite(6,HIGH); // Power the amplifier	
  	
  sampling_period_us = round(1000000*(1.0/samplingFrequency));

  if (hue_div==0)
  {
    hue_div = 1;
  }

  FastLED.addLeds<WS2812,LED_Output,GRB>(leds,LED_Count);
}


void loop()
{
  audio = digitalRead(SwitchPin1); //Change the mode, if needed
  if (audio)
  {
    fft_sum = 0;
    microseconds = micros();
    //Sample the audio
    for (i=0; i < samples; ++i){  
      data[i] = analogRead(CHANNEL);
      im[i] = 0;
      while(micros() - microseconds < sampling_period_us){}  
      microseconds += sampling_period_us;
    }
    //Calculate Fourier
    fix_fft(data,im,6,0);
    //Ignore the first 2 bins and the last 17 bins.
    for (i=2; i< samples/2-17; ++i){ 
    	//Determine the magnitude of this complex number, which gives us the amplitude.
      fft_sum += (int) sqrt(data[i] * data[i] + im[i] * im[i]); 
    }
    for (i = 0; i < LED_Count; ++i)
    {
      leds[i] = CHSV(HUE_Min+hue_div*i,255,qadd8(25,235*(fft_sum/280.0)));
    }
  }
  else
  {
    red = map(analogRead(RPot),0,1023,0,BrightMax);
    green = map(analogRead(GPot),0,1023,0,BrightMax);
    blue = map(analogRead(BPot),0,1023,0,BrightMax);
    fill_solid(leds,LED_Count,CRGB(red,green,blue));
  }
  FastLED.show();
}
